#!/usr/bin/env python

# Copyright (C) 2004  Vasco Alexandre da Silva Costa
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

import httplib, urllib, urllib2, pickle, os, sys
from optparse import OptionParser
import Cookie;

usage = "usage: %prog URL USERNAME PASSWORD"
parser = OptionParser(usage = usage)

(options, args) = parser.parse_args()
if len(args) != 3:
	parser.error("incorrect number of arguments")

# PART 1: Get the login page.
url = args[0] + '/index.php?title=Special:Userlogin'
req = urllib2.Request(url)

# Cookie jar.
jar = [
	args[0],
	'',
	'',
	''
]

# Wanted cookies.
wants = [
	'',
	'wikidbUserID',
	'wikidbUserName',
	'PHPSESSID',
]
missing = len(wants) - 1

# Do the GET.
res = urllib2.urlopen(req)
cookies = Cookie.SimpleCookie(res.info()['Set-Cookie']);

# PART 2: Login.
req = urllib2.Request(url + '&action=submit')

for (k, v) in cookies.iteritems():
	req.add_header('Cookie', k + '=' + v.value)
	if k == wants[-1]:
		jar[-1] = [k, v.value]
		missing = missing - 1

# HTTP POST arguments.
params = {
	'wpName': args[1],
	'wpLoginattempt': 'Log in',
	'wpPassword': args[2],
	'wpRemember': 1,
	'wpRetype': args[2],
	'wpEmail': '',
	'wpCreateccount': '',
}

req.add_data(urllib.urlencode(params))

# Do the POST.
res = urllib2.urlopen(req)

# Get our precious cookies.
cookies = Cookie.SimpleCookie(res.info()['Set-Cookie']);

for (k, v) in cookies.iteritems():
	try:
		index = wants.index(k, 1)
	except:
		continue
	jar[index] = [k, v.value]
	missing = missing - 1

if missing > 0:
	print "Login failed."
	sys.exit(1)
else:
	print "Login succeeded."

# Put the cookies in the jar.
f = file(os.path.expanduser('~/.wikicookiejar'), 'w')
pickle.dump(jar, f)

